;-de.asm---------------------------------------------------------------------
;              x86 - Dos - Assembly Language Programming                    ;
;                                                                           ;
; Written by: John A Lyons                                                  ;
; Email     : sysop@megablast.8k.com                                        ;
; Page      : http://www.megablast.8k.com/asm.html                          ;
; Date      : 16 September 1997                                             ;
; Compiler  : Tasm v4 (Borland Turbo Assembler), available from above page. ;
; Purpose   : Disk Editor - used to edit disks at a very low level. Not     ;
;             completed, but shows a good used of Int 25h.                  ;
;                                                                           ;
;----------------------------------------------------------------------------
;
;C:\ASM\SOURCE\DE>tasm de;
;Turbo Assembler  Version 4.0  Copyright (c) 1988, 1993 Borland International
;
;Assembling file:   de.ASM
;Error messages:    None
;Warning messages:  None
;Passes:            1
;Remaining memory:  417k
;
;
;C:\ASM\SOURCE\DE>tlink /t de;
;Turbo Link  Version 7.1.30.1. Copyright (c) 1987, 1996 Borland International
;
;C:\ASM\SOURCE\DE>de
;

                cseg segment
                assume cs:cseg, ds:cseg
                org 100H
                .286c
                jumps
main            proc far

                mov sp,offset stk+100h
                mov ah,4ah
                mov bx,(offset stk-offset main+20fh)/16
                int 21h

                mov ah,48h
                mov bx,65535
                int 21h
                mov cs:[memsiz],bx
                mov ah,48h
                int 21h         ;let steal all of mem
                mov cs:[allmem],ax

                mov ax,2
                int 10h

                call drivea

                call setup

                call disks


                mov ah,4ch
                int 21h

memsiz          dw 0
allmem          dw 0
current         db 0
ssector         dw 0,0;67dfh,1h
soffset         dw 0
csector         dw 0,0
coffset         dw 0
uoffset         dw 0
esector         dw 0,0
eoffset         dw 0
startd          dw 0
rsector         dw 0

main            endp

                                        ;Old Routines
DWRD	    PROC NEAR
                push es
                push ax
                mov ax,0b800h
                mov es,ax
                pop ax

                PUSH AX
		PUSH BX
		PUSH CX
		PUSH DX
		push si
		push di
                or ax,ax
                jne dwp
                or dx,dx
                jne dwp
		MOV ES:[DI+18],byte ptr 48
		mov al,cs:[col]
		mov es:[di+19],al
		jmp dwrdend
DWP:
		PUSH CX
		PUSH SI
		PUSH DI
		ADD DI,2

                push di
                mov cx,15
                lea di,numbspace
clear1:
                mov cs:[di],byte ptr 48
                inc di
                loop clear1
                pop di

                CALL CONDW

                LEA SI,numbspace
                MOV CX,15
                XOR AL,AL
DWB:
                MOV AH,CS:[SI]
                CMP AH,48
                jne DWC
                MOV CS:[SI],AL
                INC SI
                LOOP DWB
DWC:
		LEA SI,numbspace
                ADD SI,15
		ADD DI,16
		MOV CX,15
		MOV AL,3
		MOV DL,CS:[COL]
DWA:
		MOV AH,CS:[SI]
		cmp ah,0
                je skipszero
		MOV ES:[DI],AH
		MOV ES:[DI+1],DL
		DEC SI
		SUB DI,2
		CMP AL,0
		DEC AL
		JA DWD
skipszero:
		mov es:[di],byte ptr 32
                MOV AH,CS:[SI]
                CMP AH,0
                JE DWD
                MOV AL,44
                MOV ES:[DI],AL
                MOV ES:[DI+1],DL
                MOV AL,3
                SUB DI,2
DWD:
		LOOP DWA
DWZ:
		POP DI
		POP SI
		POP CX
dwrdend:

                mov di,0
                lea si,numbspace
                mov cx,16
clear3:
                mov al,cs:[si]
               ; mov es:[di],al
                add di,2
                inc si
                loop clear3

                pop di
		pop si
		POP DX
		POP CX
		POP BX
		POP AX

                pop es
                RET
numbspace       db 16 dup(0)
col             db 0

DWRD            ENDP

conw    proc near
	mov cx,5
	mov bx,10
	add si,4
conaaa: mov dx,0
	div bx
	ADD DL,48
	mov CS:[si],dl
	dec si
	loop conaaa
	inc si
	ret
conw	endp
condw   proc near
	LEA SI,numbspace
        add si,7
        mov bx,10000
	div bx
	push dx
	call conw
	add si,4
	pop ax
	mov dl,CS:[si]
	push dx
	call conw
	pop dx
	mov CS:[si],dl
	sub si,4
	ret
condw   endp
messdi          proc near
                push di
                call mess
                pop di
                ret
messdi          endp

mess            proc near
		push ax
                push si
;                push di
		mov ah,ch
messee:
		mov al,cs:[si]
		cmp al,0
		je messend
		mov es:[di],ax
		add di,2
		inc si
		jmp messee
messend:
;                pop di
		pop si
		pop ax
		ret
mess            endp

BOXR            PROC NEAR
		push ax
		PUSH DX
		PUSH DI
		MOV DX,WORD PTR CS:[WINDSIZ]
		MOV DI,WORD PTR CS:[WINDPOS]
		ADD DX,402H
		MOV SI,2ee0H
STOB2:
		PUSH DI
		PUSH DX
STOB1:
		MOV AX,ES:[SI]
		MOV ES:[DI],AX
		ADD SI,2
		ADD DI,2
		DEC DH
		CMP DH,0
		JA STOB1

		POP DX
		POP DI
		ADD DI,160
		DEC DL
		CMP DL,0
		JA STOB2
		POP DI
		POP DX
		pop ax
	        RET
BOXR	    ENDP
STORE	   PROC NEAR
		ADD DX,0201H
		MOV WORD PTR CS:[WINDPOS],DI
		MOV WORD PTR CS:[WINDSIZ],DX
		PUSH DI
		PUSH DX
		PUSH SI
		ADD DX,402H
		MOV SI,02ee0H
STO2:
		PUSH DI
		PUSH DX
STO1:
		MOV AX,ES:[DI]
		MOV ES:[SI],AX
		ADD SI,2
		ADD DI,2
		DEC DH
		CMP DH,0
		JA STO1
		POP DX
		POP DI
		ADD DI,160
		DEC DL
		CMP DL,0
		JA STO2
		POP SI
		POP DX
		POP DI
		SUB DX,0201H
		RET
STORE	   ENDP
window1	 proc near
		add di,160
		push di
;                xor al,al
;                stosw
		mov al,cs:[si]
		stosw
		mov al,cs:[si+1]
		xor ch,ch
		mov cl,dl
                sub cl,2
		rep stosw
		mov al,cs:[si+2]
		stosw
;                xor al,al
;                stosw
		add si,3
		pop di
		ret
window1	 endp
window2	 proc near
		push di
		call window1
		pop di
		xor ch,ch
		mov cl,dl
		shl cx,1
		add di,cx
		test cs:[shadow],1
		jz skipshad2
		mov es:[di+161],byte ptr 7
		mov es:[di+163],byte ptr 7
skipshad2:
		sub di,cx
		add di,160
		ret
window2	 endp
windowb         proc near
		push si
		lea si,wind2
		jmp winbeg
halfw:
                push si
                push di
                lea si,wind1
                add si,3

                add dx,402h
                xchg dh,dl
                mov ah,ch
                sub di,160
                jmp win1
box1:
                push ax
                xor ah,ah
                mov al,78
                sub al,dh
                add di,ax
                pop ax
box1nc:
                push si
                lea si,wind1
winbeg:
		push di

		test cs:[shadow],2
		jz skipstor1
		call store
skipstor1:
		add dx,402h
		xchg dh,dl
		mov ah,ch
		sub di,160
		call window1
win1:
		call window2
		sub si,3
		dec dh
		cmp dh,2
		jne win1
		add si,3
		call window2
		add di,158
		test cs:[shadow],1
		jnz win2
		add di,4
		jmp skipshad1
win2:
		mov es:[di+7],byte ptr 7
		add di,2
		dec dl
		jnz win2
skipshad1:

		pop di
		pop si
		ret

wind1           db 'ͻ ͼ'
wind2           db ' '
shadow          db 0
windsiz         dw 0
windpos         dw 0

windowb  endp


                                ;----=== NeW ===----;
reads           proc near
                push ds

                mov cs:[start],ax
                mov cs:[start+2],dx
                mov di,16
                call dwrd
                lea si,readd
                mov di,0
                call mess
                mov di,1
                mov cx,19
peal:
                mov es:[di],byte ptr 5dh
                add di,2
                loop peal

                push cs
                pop ds
                mov al,cs:[current]
                mov cx,-1
                lea bx,start
                int 25h
                popf

                mov di,0
                mov ax,1f00h
                mov cx,19
peal1:
                mov es:[di],ax
                add di,2
                loop peal1

                mov cs:[col],2ah
                mov ax,cs:[ssector]
                mov dx,cs:[ssector+2]
                mov di,160*24+40
                call dwrd

                mov ax,cs:[csector]
                mov dx,cs:[csector+2]
                mov di,160*24+54
                call dwrd

                mov ax,cs:[esector]
                mov dx,cs:[esector+2]
                mov di,160*24+70
                call dwrd

                mov ax,cs:[startd]
                xor dx,dx
                mov di,160*24+20
                call dwrd

                mov cs:[col],3fh

                pop ds
                ret
readd           db 'Reading',0
parmblock       equ 0
        start   dw 0,0
        number  dw 0
        offst   dw 0
        segmnt  dw 0
reads           endp

setup           proc near
                mov ax,0b800h
                mov es,ax

                mov si,1
                mov cx,2000-160
                mov al,1fh
screen:
                mov es:[si],al
                add si,2
                loop screen

                mov cx,160*2
                mov al,3fh

screen2:
                mov es:[si],al
                add si,2
                loop screen2

                mov si,160*23+2
                mov al,cs:[current]
                add al,'A'
                mov es:[si],al
                mov es:[si+2],byte ptr ':'

                mov ax,cs:[ssector]
                mov dx,cs:[ssector+2]
                mov di,160*23+20+98
                mov cs:[col],3fh
                call dwrd
                mov cs:[rsector],0

                mov si,160*23+42+98
                call hnum
                mov es:[si],byte ptr 'h'

                lea si,msect
                mov di,160*23+100
                mov ch,3fh
                call mess

                ret
msect           db 'Sectors',0
setup           endp

disks           proc near

                push ds

                mov ax,cs:[ssector]
                mov dx,cs:[ssector+2]
                mov cs:[esector],ax
                mov cs:[esector+2],dx
                mov cs:[csector],ax
                mov cs:[csector+2],dx

                mov ds,cs:[allmem]
                mov cs:[segmnt],ds
                mov cs:[offst],0
                mov cs:[number],2
                call reads

                add cs:[eoffset],512
                inc cs:[rsector]
                inc cs:[esector]
                jnc noprob1
                inc cs:[esector+2]
noprob1:

                call showit
                
                call status
                call movit

                pop ds

                ret
disks           endp

showit          proc near
                mov ax,0b800h
                mov es,ax
                mov si,160

                xor di,di

                mov cx,22
pagee1:
                call pagee
                loop pagee1

                ret
showit          endp
pagee           proc near
                push cx
                push si

;                mov ax,di
                mov ax,cs:[ssector]
                mov dx,cs:[ssector]


nolog:
                call hnum

                mov es:[si],byte ptr ':'
                add si,2

                mov bl,32
                mov ax,di
                and ax,511
                jnz noalp
                mov bl,''
noalp:
                mov es:[si],bl
                add si,2

                mov cx,16
                mov bx,104
line1:
                xor ah,ah
                mov al,ds:[di]
                inc di

                add si,bx
                mov es:[si],al
                sub si,bx

                call hex1
                sub bx,4

                mov ax,cx
                dec ax
                and al,3
                jne noale
                add si,2
                sub bx,2
noale:
                loop line1

                pop si
                add si,160

                pop cx
                ret
pagee           endp


hex1            proc near
                shl ax,4

                cmp ah,9
                ja no0
                add ah,'0'
                jmp no0b
no0:
                add ah,'A'-10
no0b:
                mov es:[si],ah

                shr al,4
                add si,2

                cmp al,9
                ja no0a
                add al,'0'
                jmp no0ba
no0a:
                add al,'A'-10
no0ba:
                mov es:[si],al

                add si,4
                ret
hex1            endp

     
hnum            proc near

                mov cx,4
herenot:
                push cx

                push dx
                push ax

                xor ah,ah
                mov al,dh
                call hex1
                sub si,2

                pop ax
                pop dx

                mov cx,8
rot1:
                clc
                rcl ax,1
                rcl dx,1
                loop rot1

                pop cx
                loop herenot

                ret
hnum            endp

movit           proc near
                push es

                mov ax,0b800h
                mov es,ax
hereweare:
                mov ah,0bh
                int 21h
                cmp al,0
                je hereweare

                in al,60h

                push es
                mov bx,40h
                mov es,bx
                mov bx,es:[1ah]
                mov es:[1ch],bx
                pop es

                cmp al,0
                je hereweare

                in al,60h

                mov es:[0],al

                cmp al,1
                je quitall


                push ax
                mov ax,cs:[coffset]
                xor dx,dx
                mov di,160*24
                call dwrd
                pop ax

                cmp al,'H'
                jne nodown
                call isdown
                jmp hereweare
nodown:
                cmp al,'P'
                jne noup
                call isup
                jmp hereweare
noup:
                cmp al,'Q'
                jne nopgdn
                call ispgdn
                jmp hereweare
nopgdn:
                cmp al,'I'
                jne nopgup
                call ispgup
                jmp hereweare
nopgup:


                cmp al,1ch
                jne noret
;                call select
                jmp hereweare
noret:


                jmp hereweare
quitall:
                pop es
                ret
movit           endp

isdown          proc near
                push ds
                mov ds,cs:[allmem]

                cmp cs:[startd],16
                jae okcont

                cmp cs:[ssector],0
                jne okcont
                cmp cs:[ssector+2],0
                jne okcont
                pop ds
                jmp quicke
okcont:

                sub cs:[startd],16
                sub cs:[coffset],16
                cmp cs:[coffset],512
                jb issara ;nojohn
                add cs:[coffset],512
                clc


                dec cs:[csector]
                jnc nojohn
                dec cs:[csector+2]
nojohn:
                mov ax,cs:[csector+2]
                cmp ax,cs:[ssector+2]
                jb notsara
                mov ax,cs:[csector]
                cmp ax,cs:[ssector]
                jae issara
notsara:
                clc
                dec cs:[ssector]
                jnc nosara1
                dec cs:[ssector+2]
nosara1:
                mov ax,cs:[ssector]
                mov dx,cs:[ssector+2]

                mov bx,cs:[soffset]
                sub bx,512
                mov cs:[soffset],bx
                mov cs:[offst],bx
                mov cs:[number],1
                call reads
issara:


                mov di,160*21+158
                mov si,160*22+158
                mov cx,80*21
repl2:
                mov ah,es:[di]
                mov es:[si],ah
                sub di,2
                sub si,2
                loop repl2

                mov si,160
                mov di,cs:[startd]
                call pagee

                pop ds
                call status
quicke:
                ret
isdown          endp

isup            proc near
                push ds
                mov ds,cs:[allmem]

                add cs:[startd],16
                add cs:[coffset],16
                cmp cs:[coffset],512
                jb okay1
                sub cs:[coffset],512
                clc
                inc cs:[csector]
                jnc nojohne
                inc cs:[csector+2]
nojohne:
                mov ax,cs:[csector]
                cmp ax,cs:[esector]
                jae notsarab
                mov ax,cs:[csector+2]
                cmp ax,cs:[esector+2]
                jbe okay1
notsarab:
                clc
                inc cs:[esector]
                jnc nosara1b
                inc cs:[esector+2]
nosara1b:
                mov ax,cs:[esector]
                mov dx,cs:[esector+2]
                push ax
                push dx
                sub ax,cs:[ssector]
                jnc noallp
                dec dx
noallp:
                sub dx,cs:[ssector+2]

                cmp ax,(65535/512)
                jb nopl
                inc cs:[ssector]
                jnc nopl
                inc cs:[ssector+2]
nopl:


                pop dx
                pop ax

                mov bx,cs:[eoffset]
                add bx,512
                mov cs:[eoffset],bx
                mov cs:[offst],bx
                mov cs:[number],1
                call reads

okay1:
                mov di,160
                mov si,160*2
                mov cx,80*21
repl1:
                mov ah,es:[si]
                mov es:[di],ah
                add di,2
                add si,2
                loop repl1

                mov si,22*160
                mov di,cs:[startd]
                add di,21*16

                call pagee

                pop ds
                call status
                ret
isup            endp

getsect         proc near

                mov cs:[segmnt],ds
                mov ax,cs:[eoffset]
                mov cs:[offst],ax
                mov ax,cs:[esector]
                mov dx,cs:[esector+2]
                mov cs:[number],1
                call reads

                cmp cs:[eoffset],65024
                jb nosara
                sub cs:[eoffset],512
                dec cs:[ssector]
                jnc nosara
                dec cs:[ssector+2]
nosara:
                add cs:[eoffset],512
                inc cs:[rsector]
                inc cs:[esector]
                jnc noinc2
                inc cs:[esector+2]
noinc2:

                ret
getsect         endp

status          proc near


                mov ax,cs:[csector]
                mov dx,cs:[csector+2]

                cmp ax,cs:[olddisp]
                je endallag
                mov cs:[olddisp],ax

                mov di,160*23+20+98
                mov cs:[col],3fh
                call dwrd

                mov si,160*23+42+98
                call hnum
                mov es:[si],byte ptr 'h'

endallag:
                ret
olddisp         dw 0
status          endp

ispgdn          proc near

                push ds
                mov ds,cs:[allmem]

okay2:
                add cs:[startd],16*21
                add cs:[coffset],16*21
                cmp cs:[coffset],512
                jb noch12
                sub cs:[coffset],512
                inc cs:[csector]
                jnc noch12
                inc cs:[csector+2]
noch12:
                mov ax,cs:[csector+2]
                cmp ax,cs:[esector+2]
                ja readall
                mov ax,cs:[csector]
                cmp ax,cs:[esector]
                jb dontread
readall:
                call getsect
dontread:


                mov si,160
                mov di,cs:[startd]

                mov cx,22
                mov bx,100
line2:
                call pagee

                loop line2

                pop ds
                call status
                ret

                ret
ispgdn          endp

ispgup          proc near
                push ds
                mov ds,cs:[allmem]

                cmp cs:[startd],16*21
                jae okcont1

                cmp cs:[ssector],0
                jne okcont1
                cmp cs:[ssector+2],0
                jne okcont1
                pop ds
                jmp quicke1
okcont1:

                sub cs:[startd],16*21
                sub cs:[coffset],16*21
                cmp cs:[coffset],512
                jb nojohn1
                add cs:[coffset],512
                clc
                dec cs:[csector]
                jnc nojohn1
                dec cs:[csector+2]
nojohn1:

                mov si,160
                mov di,cs:[startd]

                mov cx,22
                mov bx,100
line2b:
                call pagee

                loop line2b

                pop ds
                call status
quicke1:
                ret
ispgup          endp

drivea    proc near
                mov ax,0b800h
                mov es,ax

                mov di,996+160
	        mov dx,2407h
		mov cs:[shadow],3
		mov ch,3bh
                call box1nc
		push di

		add di,186
		lea si,selecta
		mov ch,3fh
		call mess

		pop di
		add di,326
                mov dx,1e04h
		mov cs:[shadow],0
		mov ch,3ah
                call box1nc

		add di,166
                call driveinfo

                mov bl,0eh
                call barone

hereweare1a:
                mov ah,0bh
                int 21h
                cmp al,0
                je hereweare1a

                in al,60h

                push es
                mov bx,40h
                mov es,bx
                mov bx,es:[1ah]
                mov es:[1ch],bx
                pop es

                cmp al,0
                je hereweare1a

                in al,60h

                mov es:[0],al

                cmp al,1
                je quitalla


                cmp al,'P'
                jne nod1
                mov al,cs:[bar2]
                inc al
                cmp al,cs:[maxdrive]
                je hereweare1a
                jmp hereweare1b

nod1:
                cmp al,'H'
                jne nod2
                mov al,cs:[bar2]
                cmp al,0
                je hereweare1a
                dec al
                jmp hereweare1b
nod2:
                cmp al,''
                jne nod3
                mov di,996+160+326+166
                xor ah,ah
                mov al,cs:[bar2]
                mov cx,160
                mul cx
                add di,ax

                mov al,es:[di]
                sub al,'A'
                mov cs:[current],al
                mov cs:[soffset],0
                mov cs:[ssector],dword ptr 0
                jmp quitalla
nod3:
                jmp hereweare1a
hereweare1b:
                push ax

                mov bl,3fh
                call barone

                pop ax
                mov cs:[bar2],al
                mov bl,0eh
                call barone
                jmp hereweare1a
quitalla:
                call boxr
		ret

selecta  db 'Select drive',0
bar2            db 0
drivea    endp

barone          proc near
                mov di,996+160+326+164
                xor ah,ah
                mov al,cs:[bar2]
                mov cx,160
                mul cx
                add di,ax

                mov cx,30
bar1aa:
                inc di
                mov es:[di],byte ptr bl
                inc di
                loop bar1aa

                ret
barone          endp


driveinfo       proc near
                mov dl,0
drivelp1:
		push dx

                cmp dl,1
                ja nodrive

                push es
		push di
		mov ah,8
		int 13h
		pop di
		pop es

		jc nodrive
		or bl,bl
		jz nodrive

		mov cl,bl
		xor ch,ch
		lea si,drives
search2:
		cmp cx,1
		je ready1
search1:
		inc si
		cmp cs:[si-1],byte ptr 0
		jne search1
		dec cx
		jmp search2
ready1:
		add di,6
                mov ch,3fh
                call messdi

		lea si,driveq
		cmp bl,2
		jb dirveok1
		lea si,drivet
dirveok1:
		add di,18
                call messdi

		add di,16
		lea si,floopy
                call messdi

		sub di,40
                inc cs:[maxdrive]
                jmp gotdirve
nodrive:
		pop bx
		push bx

		cmp bl,1
		ja checkdev
		jmp notfound
checkdev:
		mov ax,440dh
		inc bl
                mov cx,860h
		mov dx,80h
		int 21h

		jnc letsgoa4
		jmp nodirve1
letsgoa4:
		add di,6
		push ds
			mov si,87h

			mov ax,ds:[si+8]
			xor dx,dx
			cmp ax,0
			jne sectok23
			mov ax,ds:[si+15h]
                       mov dx,ds:[si+17h]
sectok23:
			push ax
			mov ax,dx
			mul word ptr cs:[si]
			mov cx,ax
			pop ax
			mul word ptr cs:[si]
			add dx,cx

                        mov cx,20
rot1a:
                        clc
                        rcr dx,1
                        rcr ax,1
                        loop rot1a

			sub di,12
                        mov cs:[col],3fh
			call dwrd
			add di,6

                        mov ax,3f4dh
                        mov es:[di+16],ax
                        mov ax,3f62h
                        mov es:[di+18],ax


			mov al,ds:[81h]
			lea si,fixed
			cmp al,5
			je show1
			lea si,taped
			cmp al,6
			je show1
			lea si,devil
			cmp al,7
			je show1
show1:

			add di,22
                        mov ch,3fh
                        call messdi
			add di,12

			cmp al,7
			je skipdrive1

			lea si,drivel
                        call messdi
                        inc cs:[maxdrive]
skipdrive1:
		pop ds
		sub di,34
		jmp gotdirve

nodirve1:
		pop bx
                push bx

		mov ax,4409h
		inc bl
		int 21h
		jc nodirve3

                inc cs:[maxdrive]
		lea si,locally
		and dx,2048
		jnz notlocal
		lea si,remotely
notlocal:
		add di,6
                mov ch,3fh
                call messdi

		add di,16
		lea si,devil
                call messdi

		sub di,22
		jmp gotdirve
nodirve3:
       	 jmp notfound
gotdirve:
		pop dx
		push dx

                mov ah,3fh
                mov al,dl
		add al,65
                mov es:[di],ax
                mov al,':'
                mov es:[di+2],ax
		add di,160
notfound:
		pop dx

		inc dl
		cmp dl,20
		je thend3
                jmp drivelp1
thend3:
		ret

drives          db ' 360 Kb ,',0
                db ' 1.2 Mb ,',0
                db ' 720 Kb ,',0
                db '1.44 Mb ,',0
drivet          db '3 inch',0
driveq          db '5 inch',0
floopy          db 'floppy',0
fixed           db ',hard',0
taped           db ',tape',0
devil           db ',device driver',0
drivel          db 'drive',0
locally         db 'local',0
remotely        db 'remote',0
maxdrive        db 0

driveinfo       endp

stk             equ $
cseg ends
end main
